std::vector::end,std::vector::cend(3)

NAME
std::vector::end,std::vector::cend - std::vector::end,std::vector::cend

Synopsis
   iterator end(); (until C++11)
   iterator end() noexcept; (since C++11)
                        (until C++20)
   constexpr iterator end() noexcept; (since C++20)
   const_iterator end() const; (until C++11)
   const_iterator end() const noexcept; (since C++11)
                        (until C++20)
   constexpr const_iterator end() const noexcept; (since C++20)
   const_iterator cend() const noexcept; (since C++11)
                        (until C++20)
   constexpr const_iterator cend() const noexcept; (since C++20)
   Returns an iterator to the element following the last element of the vector.
   This element acts as a placeholder; attempting to access it results in undefined
   behavior.
   range-begin-end.svg

Parameters
   (none)

Return value
   Iterator to the element following the last element.

Complexity
   Constant.

Example
// Run this code
 #include <algorithm>
 #include <iostream>
 #include <numeric>
 #include <string>
 #include <vector>
 int main()
 {
     std::vector<int> nums {1, 2, 4, 8, 16};
     std::vector<std::string> fruits {"orange", "apple", "raspberry"};
     std::vector<char> empty;
     // Print vector.
     std::for_each(nums.begin(), nums.end(), [](const int n) { std::cout << n << ' '; });
     std::cout << '\n';
     // Sums all integers in the vector nums (if any), printing only the result.
     std::cout << "Sum of nums: "
               << std::accumulate(nums.begin(), nums.end(), 0) << '\n';
     // Prints the first fruit in the vector fruits, checking if there is any.
     if (!fruits.empty())
         std::cout << "First fruit: " << *fruits.begin() << '\n';
     if (empty.begin() == empty.end())
         std::cout << "vector 'empty' is indeed empty.\n";
 }

Output:
 1 2 4 8 16
 Sum of nums: 31
 First fruit: orange
 vector 'empty' is indeed empty.

See also
   begin returns an iterator to the beginning
   cbegin (public member function)
   (C++11)
   end
   cend returns an iterator to the end of a container or array
   (C++11) (function template)
   (C++14)